// Zivoty.cpp: implementation of the Zivoty class.
//
//////////////////////////////////////////////////////////////////////

#include <afxwin.h>
#include "..\defines.h"
#include "resource.h"
#include "..\ufo.h"
#include "Zivoty.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Zivoty::Zivoty()
{
	m_p1 = new CBitmap;
	m_p1->LoadBitmap(IDB_ZIVOTY_1);

	m_p2 = new CBitmap;
	m_p2->LoadBitmap(IDB_ZIVOTY_2);

}

Zivoty::~Zivoty()
{
	delete m_p1;
	delete m_p2;
}

void Zivoty::Test(CDC *dc, CRect rect, Ufo1 *pl1, Ufo2 *pl2, CBitmap *pozadi, Meteor *meteor, bool kresli/*=false*/)
{
	int an = 0;
	if (pl1->p_ufo.x > pl2->p_ufo.x) an = 1;

	kresli |= pl1->Test(pozadi,rect,dc,pl2,an)| pl2->Test(pozadi,rect,dc,pl1,an) |
				 meteor->Test(pozadi,rect,dc,pl1,an) | meteor->Test(pozadi,rect,dc,pl2,an);

	if (kresli) 
		if (pl1->lives <= 0) Zobraz(dc,rect,pozadi,0,pl2->lives);
		else if (pl2->lives <= 0) Zobraz(dc,rect,pozadi,pl1->lives,0);
			else Zobraz(dc,rect,pozadi,pl1->lives,pl2->lives);
}

void Zivoty::Zobraz(CDC *dc, CRect rect, CBitmap *pozadi, int lives1, int lives2)
{
	CDC cdc;
	cdc.CreateCompatibleDC(dc);
	CBitmap *p_cdc = cdc.SelectObject(pozadi);
	
	dc->StretchBlt((290*lives1*rect.right)/(LIVES*PLOCHAX),0,
						(20+(290*(1000-lives2-lives1)/LIVES))*rect.right/PLOCHAX, LIVES_Y*rect.bottom/PLOCHAY, &cdc, 
						290*lives1/LIVES,0,
						20+(290*(1000-lives1-lives2)/LIVES),LIVES_Y,SRCCOPY);
	
	cdc.SelectObject(p_cdc);
}


void Zivoty::Reset(CDC *dc, CRect rect)
{
	CDC cdc;
	cdc.CreateCompatibleDC(dc);
	CBitmap *p_cdc = cdc.SelectObject(m_p1);
	dc->StretchBlt(0,0,290*rect.right/PLOCHAX,LIVES_Y*rect.bottom/PLOCHAY,&cdc,0,0,290,LIVES_Y,SRCCOPY);
	cdc.SelectObject(m_p2);
	dc->StretchBlt(310*rect.right/PLOCHAX, 0,290*rect.right/PLOCHAX, LIVES_Y*rect.bottom/PLOCHAY, &cdc, 0, 0, 290, LIVES_Y, SRCCOPY);
	cdc.SelectObject(p_cdc);
}

void Zamaluj_strelu(CDC *dc, CRect rect, CBitmap *pozadi, CPoint point, int x, int y)
{
	CDC cdc;
	cdc.CreateCompatibleDC(dc);
	CBitmap *p_cdc = cdc.SelectObject(pozadi);

	dc->StretchBlt((point.x-(x/2+3))*rect.right/PLOCHAX,(point.y-(y/2+3))*rect.bottom/PLOCHAY, (x+6)*rect.right/PLOCHAX, (y+6)*rect.bottom/PLOCHAY, &cdc,point.x-(x/2+3),point.y-(y/2+3),x+6,y+6,SRCCOPY);

	cdc.SelectObject(p_cdc);
}
