/*
   Bernard Lidicky - 1999 (c)
	Star Shooter 2.00
	
*/
#include <afxwin.h>
#include <time.h>
#include <winuser.h>

#include "defines.h"
#include "rc\resource.h"
#include "ufo.h"
#include "about.h"
#include "rc\zivoty.h"
#include "nadpis.h"
#include "rc\nova.h"

Aplikace A;


BOOL Aplikace::InitInstance() {
		
	SetRegistryKey("Hippo Games");

	// zobrazeni okna
	m_pMainWnd = new Wokno;
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	return TRUE;
}

Aplikace::~Aplikace()
{
	delete m_pMainWnd;
}


BEGIN_MESSAGE_MAP(Wokno, CFrameWnd)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_MBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_CLOSE()
	// menu
	ON_COMMAND(IDM_NAPIS_KONEC, _Konec)
	ON_COMMAND(IDM_HRA_NOVA, _Nova)
	ON_COMMAND(IDM_NAPOVEDA_OAPLIKACI, _About)
END_MESSAGE_MAP()

Wokno::Wokno() {
  
	
	srand( (unsigned)time( NULL ) );

	CRect rect;
	CString str = AfxGetApp()->GetProfileString("Vzhled", "pozice");
	if (!(str.IsEmpty())) rect.SetRect(atoi((const char*) str),atoi((const char*) str + 5),
												 atoi((const char*) str + 10),atoi((const char*) str + 15));
	else rect.SetRect(0,0,PLOCHAX,PLOCHAY);


// tvoreni okna
	Create(NULL, "Star Shooter 2.00",WS_OVERLAPPEDWINDOW /*& (~(WS_MAXIMIZEBOX | WS_THICKFRAME))*/,rect,NULL,NULL);
	CenterWindow();

	GetClientRect(&Plocha);
	Plocha.right -= Plocha.left;
	Plocha.bottom -= Plocha.top;
	Plocha.left = 0;
	Plocha.top = 0;
// pridani menu
	CMenu menu;
	menu.LoadMenu(IDR_MENU);
	SetMenu(&menu);
	menu.Detach();

// nastaveni ikonky
	HICON hIcon = AfxGetApp()->LoadIcon(IDI_ICON);
	SetIcon(hIcon, TRUE);
	SetIcon(hIcon, FALSE);

// init bitampy
	m_pPlocha = new CBitmap;
	m_pPlocha->LoadBitmap(IDB_PLOCHA);


	m_uTimerID = SetTimer(5,30,NULL);

	// urcuje zpusob hry - z registru
	if(AfxGetApp()->GetProfileInt("Hra","PL1",-1) == 1 ) PL1.automat = true;
	else PL1.automat = false;
	
	if(AfxGetApp()->GetProfileInt("Hra","PL2",-1) == 1 ) PL2.automat = true;
	else PL2.automat = false;
	
	CDC *dc = GetDC();
	PL1.Init(dc);
	PL2.Init(dc);
	ReleaseDC(dc);

	// init nove hry
	PostMessage(WM_COMMAND,IDM_HRA_NOVA);

}

Wokno::~Wokno() {
	delete m_pPlocha;
	m_pPlocha = 0;
	
	// ulozeni dat do registru - pozice okna - nefunguje
	CString str;
	str.Format("%04d %04d %04d %04d",rect.left,rect.top,rect.right,rect.bottom);
	AfxGetApp()->WriteProfileString("Vzhled", "pozice",str);

	KillTimer(m_uTimerID);

}

void Wokno::OnPaint() {

	CWnd::OnPaint();

	CDC cdc;
	CDC *dc_obrazovka = GetDC();
	CDC dc;

	CBitmap *swp;

	swp = new CBitmap;
	swp->CreateCompatibleBitmap(dc_obrazovka,Plocha.right,Plocha.bottom);

	dc.CreateCompatibleDC(dc_obrazovka);
	CBitmap *p_dc = dc.SelectObject(swp);

	// placnuti bitmapy
	cdc.CreateCompatibleDC(dc_obrazovka);
	CBitmap *pOB = cdc.SelectObject(m_pPlocha);
	dc.StretchBlt (0,0,Plocha.right,Plocha.bottom,&cdc,0,0,PLOCHAX,PLOCHAY,SRCCOPY);
	cdc.SelectObject(pOB);
	
	// njprve strely, pak rakety - aby strely neumazaval rakety
	PL1.Zobraz_strely(m_pPlocha,Plocha,&dc);
	PL2.Zobraz_strely(m_pPlocha,Plocha,&dc);
	m_meteor.Zobraz(m_pPlocha,Plocha,&dc);
	PL1.Zobraz(m_pPlocha,Plocha,&dc);
	PL2.Zobraz(m_pPlocha,Plocha,&dc);

	p_zivoty.Reset(&dc,Plocha);
	p_zivoty.Test(&dc, Plocha, &PL1, &PL2, m_pPlocha, &m_meteor, true);

	dc_obrazovka->BitBlt(0,0,Plocha.right,Plocha.bottom,&dc,0,0,SRCCOPY);
	
	ReleaseDC(dc_obrazovka);
	dc.SelectObject(p_dc);
	delete swp;
}

void Wokno::OnClose() {
	WINDOWPLACEMENT wpl;
	GetWindowPlacement(&wpl);
	rect = wpl.rcNormalPosition;

	PostMessage(WM_QUIT);
}

void Wokno::_Konec() {
	SendMessage(WM_CLOSE,0,0);
}

void Wokno::_Nova() {
	 /* dialog nove hry*/
		PL1.Reset();
		PL2.Reset();
		PL1.killed = 0;
		PL2.killed = 0;
		SendMessage(WM_PAINT);
		CNova nova(this);
		nova.DoModal();
}

void Wokno::OnMouseMove(UINT nFlags, CPoint point) {
	if (PL1.automat == true) return;
	PL1.p_dest.x = long((PLOCHAX*point.x)/(Plocha.right));
	PL1.p_dest.y = long((PLOCHAY*point.y)/(Plocha.bottom));

	CWnd::OnMouseMove(nFlags, point);
}

void Wokno::OnTimer(UINT nIDEvent)
{
 	static int anim = 0;  // aktualni okenko animace
	int an = 0; // urcuje, ktera lod je vlevo / vpravo
	static int later = 0; // zpozduje animaci

	CWnd::OnTimer(nIDEvent);

	CDC *dc = GetDC();

	// Urceni smeru raket
	if (PL1.p_ufo.x < PL2.p_ufo.x) {
		an = 0;
		PL1.speed_shoot = SHOOT_SPEED;
		PL2.speed_shoot = -SHOOT_SPEED;
	}
	else {
		an = 1;
		PL1.speed_shoot = -SHOOT_SPEED;
		PL2.speed_shoot = SHOOT_SPEED;
	}


	if (++later > 100) later = 0;
	if (later%5 == 0) {
		if (++anim > 2) anim = 0; // zacikleni animace
		PL1.m_pUfo = PL1.m_animace[an][anim];
		PL1.m_pUfo_black = PL1.m_animace_black[an][anim];
		PL2.m_pUfo = PL2.m_animace[an][anim];
		PL2.m_pUfo_black = PL2.m_animace_black[an][anim];
	}

	// pohyb raket
	if (PL1.lives <= 0) {
		if (PL1.lives >= -60) {
			PL1.m_pUfo = PL1.m_animace[an][abs(PL1.lives--)/6];
			PL1.m_pUfo_black = PL1.m_animace_black[an][abs(PL1.lives--)/6];
		}
		else {
			if ((++PL2.killed < KILLED)||(PL1.automat&&PL2.automat))PL1.Reset();
			else { // konec hry
				KillTimer(m_uTimerID);
				m_uTimerID = 0;
				MessageBox("Je konec imperatora! \n Vudce povstalcu Zakhan se dostava do cela nove vlady a nici posledni zbytky privrzencu imperatora... ","End..");
				SendMessage(WM_COMMAND, IDM_HRA_NOVA);
			}
			p_zivoty.Reset(dc,Plocha);
			p_zivoty.Test(dc, Plocha, &PL1, &PL2, m_pPlocha, &m_meteor,true);
		}
	}

	// druha raketa
	if (PL2.lives <= 0) {
		if (PL2.lives >= -60) {
			PL2.m_pUfo = PL2.m_animace[an][abs(PL2.lives--)/6];
			PL2.m_pUfo_black = PL2.m_animace_black[an][abs(PL2.lives--)/6];
		}
		else {
			if ((++PL1.killed < KILLED)||(PL1.automat&&PL2.automat)) PL2.Reset();
			else { // konec hry
				KillTimer(m_uTimerID);
				m_uTimerID = 0;
				MessageBox("Jednotky povstalcu jsou porazeny! \n Pokracuje vlada imperatora Yarrdesehe I., ktery se tvrde msti ...","End..");
				SendMessage(WM_COMMAND, IDM_HRA_NOVA);
			}
			p_zivoty.Reset(dc,Plocha);
			p_zivoty.Test(dc, Plocha, &PL1, &PL2, m_pPlocha, &m_meteor,true);
		}
	}

	PL1.Move(m_pPlocha,Plocha,dc,PL2.p_ufo);
	PL2.Move(m_pPlocha,Plocha,dc,PL1.p_ufo);

	m_meteor.Move(dc,Plocha,m_pPlocha);

	p_zivoty.Test(dc, Plocha, &PL1, &PL2, m_pPlocha, &m_meteor);

	// vlastni zobrazeni
	PL1.Zobraz_strely(m_pPlocha,Plocha,dc);
	PL2.Zobraz_strely(m_pPlocha,Plocha,dc);
	m_meteor.Zobraz(m_pPlocha,Plocha,dc);
	PL1.Zobraz(m_pPlocha,Plocha,dc);
	PL2.Zobraz(m_pPlocha,Plocha,dc);
	
	ReleaseDC(dc);
	// Eat spurious WM_TIMER messages
	
	MSG msg;
	while(::PeekMessage(&msg, m_hWnd, WM_TIMER, WM_TIMER, PM_REMOVE));
	
}

void Wokno::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) {
// zpracovani stisku klavesy
	if ((PL1.automat == false)&&(nChar == VK_RETURN)) PL1.st_task = TASK_UP;
	
	if (PL2.automat == true) {
		return;
	}

	switch (nChar) {
		case VK_NUMPAD4:
		case VK_LEFT: {
			PL2.p_dest.x = PL2.kraj.left;
			PL2.p_dest.y = PL2.p_ufo.y;
			break;
		  };
		case VK_NUMPAD6:
		case VK_RIGHT: {
			PL2.p_dest.x = PL2.kraj.right;
			PL2.p_dest.y = PL2.p_ufo.y;
			break;
			};
		case VK_NUMPAD8:
		case VK_UP: {
			PL2.p_dest.x = PL2.p_ufo.x;
			PL2.p_dest.y = PL2.kraj.top;
			break;
			};
		case VK_NUMPAD2:
		case VK_DOWN:{
			PL2.p_dest.x = PL2.p_ufo.x;
			PL2.p_dest.y = PL2.kraj.bottom;
			break;
			};
		case VK_NUMPAD7:
		case VK_HOME:{
			PL2.p_dest.x = PL2.kraj.left;
			PL2.p_dest.y = PL2.kraj.top;
			break;
			};
		case VK_NUMPAD9:
		/*case VK_PAGE_UP:*/{
			PL2.p_dest.x = PL2.kraj.right;
			PL2.p_dest.y = PL2.kraj.top;
			break;
			};
		case VK_NUMPAD1:
		case VK_END:{
			PL2.p_dest.x = PL2.kraj.left;
			PL2.p_dest.y = PL2.kraj.bottom;
			break;
			};
		case VK_NUMPAD3:
		/*case VK_PAGE_DOWN:*/{
			PL2.p_dest.x = PL2.kraj.right;
			PL2.p_dest.y = PL2.kraj.bottom;
			break;
			};
		case VK_NUMPAD0:
		case VK_INSERT:{
			PL2.p_dest.x = PL2.p_ufo.x;
			PL2.p_dest.y = PL2.p_ufo.y;
			break;
			};
		case VK_SPACE : {
			PL2.st_task = TASK_LR;
			break;
			};
		case 'C' : {
			PL2.st_task = TASK_UP;
			break;
			};
		case 'X' :	{
			PL2.st_task = TASK_DN;
			break;
			};

		default:
			break;
	};

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void Wokno::OnLButtonDown(UINT nFlags, CPoint pint){
	if (PL1.automat == true) return;

	PL1.st_task = TASK_LR;
	
	CWnd::OnLButtonDown(nFlags,pint);
}

void Wokno::OnRButtonDown(UINT nFlags, CPoint pint){
	if (PL1.automat == true) return;

	PL1.st_task = TASK_DN;

	CWnd::OnRButtonDown(nFlags,pint);
}

void Wokno::OnMButtonDown(UINT nFlags, CPoint pint){
	if (PL1.automat == true) return;

	PL1.st_task = TASK_DN;
	
	CWnd::OnMButtonDown(nFlags,pint);
}


void Wokno::OnSize(UINT flag, int cx, int cy) {

	GetClientRect(&Plocha);
	Plocha.right -= Plocha.left;
	Plocha.bottom -= Plocha.top;

	CWnd::OnSize(flag,cx,cy);
}


int Nahoda(int nrOfSides)
{
	int testpoint;
	int r = rand();			// rand() vypot nhodn slo v rozsahu  a0x7FFF

	// konstanta RAND_MAX je definovna ve stdio.h na 0x07FFF
	int breakpoint = RAND_MAX / nrOfSides;  // rozdl RAND_MAX 
											//  na rovnomrn dly
	for (int c = 1; c < nrOfSides; c++) {	// Testuje kad rozsah
		testpoint = c * breakpoint;
		if (r < testpoint)
			break;		 // konec pi nalezen
	}	
	
	return (c - 1);	// vrt slo hodu
}

void Wokno::_About()
{
	CAbout dlg;
	dlg.DoModal();
	SendMessage(WM_PAINT);
}

